package javax.swing.text.html.parser;

import java.util.Hashtable;

public final class Entity implements DTDConstants
{
    public String name;
    public int type;
    public char[] data;
    static Hashtable<String, Integer> entityTypes;
    
    public Entity(String name, int type, char[] data) {
        this.name = name;
        this.type = type;
        this.data = data;
    }
    
    public String getName() {
        return this.name;
    }
    
    public int getType() {
        return this.type & 0xFFFF;
    }
    
    public boolean isParameter() {
        return (this.type & 0x40000) != 0x0;
    }
    
    public boolean isGeneral() {
        return (this.type & 0x10000) != 0x0;
    }
    
    public char[] getData() {
        return this.data;
    }
    
    public String getString() {
        return new String(this.data, 0, this.data.length);
    }
    
    public static int name2type(String key) {
        Integer n = (Integer)Entity.entityTypes.get(key);
        return (n == null) ? 1 : ((int)n);
    }
    
    static {
        (Entity.entityTypes = new Hashtable()).put("PUBLIC", Integer.valueOf(10));
        Entity.entityTypes.put("CDATA", Integer.valueOf(1));
        Entity.entityTypes.put("SDATA", Integer.valueOf(11));
        Entity.entityTypes.put("PI", Integer.valueOf(12));
        Entity.entityTypes.put("STARTTAG", Integer.valueOf(13));
        Entity.entityTypes.put("ENDTAG", Integer.valueOf(14));
        Entity.entityTypes.put("MS", Integer.valueOf(15));
        Entity.entityTypes.put("MD", Integer.valueOf(16));
        Entity.entityTypes.put("SYSTEM", Integer.valueOf(17));
    }
}
